//*************************************************************
//
// Copyright 2006 by O.kocatrk
//
//*************************************************************

unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Grids, StdCtrls, Math, ComCtrls, Menus, Dialogs, MMSystem, sAdapter,
  sGridAdapter, sDialogs, sSkinProvider, sSkinManager, sGauge, sComboBox,
  sTrackBar, sCheckBox, sLabel, sSpeedButton, ExtCtrls, sPanel,
  Registry, Buttons;

type
  TSudokuArray = array[1..9, 1..9] of integer; // iki boyutlu dizi

type
  TRandomDigitsArray = array[1..9] of integer;

type
  TfrmSudoku = class(TForm)
    PrinterSetupDialog1: TPrinterSetupDialog;
    sknMngr: TsSkinManager;
    sknProvider: TsSkinProvider;
    pnMain: TsPanel;
    SudokuGrid: TStringGrid;
    sPanel2: TsPanel;
    pnHeader: TsPanel;
    pnfooter: TsPanel;
    ProgGauge: TsGauge;
    btnOpenGame: TsSpeedButton;
    btnSaveGame: TsSpeedButton;
    btnNewGame: TsSpeedButton;
    btnSolveGame: TsSpeedButton;
    btnPrnPreviewGame: TsSpeedButton;
    btnPrintGame: TsSpeedButton;
    cbShowTips: TsCheckBox;
    cbColored: TsCheckBox;
    lbMouseInCell: TsLabelFx;
    lbSelectedCell: TsLabelFx;
    btnExit: TsSpeedButton;
    sSpeedButton1: TsSpeedButton;
    sSpeedButton2: TsSpeedButton;
    sSpeedButton3: TsSpeedButton;
    sSpeedButton4: TsSpeedButton;
    sSpeedButton6: TsSpeedButton;
    sSpeedButton7: TsSpeedButton;
    sSpeedButton8: TsSpeedButton;
    sSpeedButton9: TsSpeedButton;
    sSpeedButton10: TsSpeedButton;
    tbDifLevel: TsTrackBar;
    sSpeedButton11: TsSpeedButton;
    lbLogo: TsLabelFX;
    lbAuthor: TsLabelFX;
    sLabelFx3: TsLabelFx;
    lbDifLevel: TsLabelFX;
    cbSkinList: TsComboBox;
    SaveDlg: TsSaveDialog;
    OpenDlg: TsOpenDialog;
    sknGrdAdapter: TsGridAdapter;
    btnCustomGame: TsSpeedButton;
    cbSoundEffects: TsCheckBox;
    sLabelFX1: TsLabelFX;
    sLabelFX2: TsLabelFX;
    lbInputCount: TsLabelFX;
    lbEstCount: TsLabelFX;
    procedure cbSoundEffectsClick(Sender: TObject);
    procedure lbAuthorMouseEnter(Sender: TObject);
    procedure lbAuthorMouseLeave(Sender: TObject);
    procedure SudokuGridMouseLeave(Sender: TObject);
    procedure tbDifLevelChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnCustomGameClick(Sender: TObject);
    procedure cbSkinListClick(Sender: TObject);
    procedure pnHeaderMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; x, y: Integer);
    procedure cbShowTipsClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure btnPrintGameClick(Sender: TObject);
    procedure btnPrnPreviewGameClick(Sender: TObject);
    procedure btnSaveGameClick(Sender: TObject);
    procedure btnOpenGameClick(Sender: TObject);
    procedure btnSolveGameClick(Sender: TObject);
    procedure btnNewGameClick(Sender: TObject);
    procedure cbColoredClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SudokuGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure SudokuGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; x, y: Integer);

    procedure SudokuGridMouseMove(Sender: TObject; Shift: TShiftState; x, y:
      Integer);
    procedure SudokuGridKeyPress(Sender: TObject; var Key: Char);
    procedure SudokuGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);

    procedure ClickKeyPadButtons(Sender: TObject);

  private

  public
    ColoredBoxes: Boolean; // printpreview iindende arlacak o yzden public

    procedure SendKeyPadValues(var KeyPadButtonValue: Char);
    procedure Sleep(Miliseconds: Cardinal);
    function GameIsSolved: boolean;
    procedure ClearSudokuGrid;
    procedure CreateSudokuMask;
    procedure GenerateSudokuGrid(Solved: boolean);
    procedure ShowGameIsSolvedMessage;
    procedure SaveGameToFile(FileName: string);
    procedure OpenGameFromFile(FileName: string);
    function CheckValueIsPossible(InputValue: integer; SourceColumn: integer;
      SourceRow: integer; SourceArray: TSudokuArray): Boolean;
    function CreateSolvedGame(SourceArray: TSudokuArray; Gauge: TsGauge):
      boolean;
    function CreateBlankCellMap(SourceArray: TSudokuArray; BlankCellCount:
      integer; DiffLevel: integer): boolean;
    function FindGroup(Row: integer; Column: integer): string;
    function GetPossibilities(NumberStr_27_Value: string): string;
    function NumberRefsForColRow(Column: integer; Row: integer; SourceArray:
      TSudokuArray): string;
    procedure CreateRandomDigitsArray(var SourceRandomDigitsArray:
      TRandomDigitsArray);
    procedure ReadWriteSettings(Read: Boolean);
    procedure DisplayHint(Sender: TObject);
    function EnDeCryptSudoku(const Value: string): string;
  end;

const
  SudokuCellSum     = 405; // 81 hcre deki verilerin toplam oyunun zmn kontrol etmek iin kullanlacak
  NoSelect          : TGridRect = (Left: - 1; Top: - 1; Right: - 1; Bottom: - 1);  //seimi gridin dnda tutmak iin

var
  frmSudoku         : TfrmSudoku;
  GridColumn, GridRow: integer;
  UserKeyCount      : Integer; // bu deiken kullancnn doru girdii rakam saysn tutacak

  EditableCellsArray  : array[0..8, 0..8] of boolean;
    {EditableCellsArray dizi si grid zerinde
                                                     deitirilmesine msaade edilecek hcrelerin
                                                     bilgilerini tutar}

  AutoSolveHighlighterArray: array[0..8, 0..8] of boolean;  // oyunu program zerse zd hcreler
                                                           // oyuncunun zdklerinden farkl renkte
                                                           //olmas iin tanmland.

  SolvedGameArray   : TSudokuArray; //Oyun nce burda zlr sonra zorluk seviyesine gre baz hcreler silinir

  EnableSolvedMessage: boolean;

  PossibilityArray  : array[1..9, 1..9] of string;  // her hcre iin girilebilecek ihtimalleri ayr ayr tutar

  BaseNumbers       : string; // seili bo hcreye girilebilecek tm ihtimaller(1,2,3,4,5,6,7,8,9)
  DiffLevel         : Integer; // zorluk seviyesi yani bo hcre says

  AutoSolve         : Boolean; // oyun program tarafndan zlnce True
  CustomGame        : Boolean; // Grid temizlenip kii kendisi hcreleri doldurursa True
  KeyPadEnabled     : Boolean; // eer grid tamamen doluysa false olacak ve tu basmayacak
  EnableSoundEffects: Boolean; // eer true olursa baz ses efektleri kullanlr

implementation

{$R *.dfm}
{$R Sounds.res}
uses frmPrintPreview;

function TempFolder: string; // oyunu geici olarak kaydetmek iin temp yolunu tesbit ediyor

var
  bufFolder         : array[0..MAX_PATH] of Char;

begin
  GetTempPath(SizeOf(bufFolder), bufFolder);
  Result := IncludeTrailingPathDelimiter(string(bufFolder));
end;

procedure TfrmSudoku.DisplayHint(Sender: TObject);
begin
  Application.Showhint := true;
  lbMouseInCell.Caption := Application.Hint;
end;

procedure TfrmSudoku.ReadWriteSettings(Read: Boolean);

var
  RegIni            : TRegIniFile;
  ProgKey           : string;

begin
  ProgKey := 'SOFTWARE\SUDOKUTurk';
  RegIni := TRegIniFile.Create('');
  RegIni.RootKey := HKEY_LOCAL_MACHINE;

  with RegIni do

    try
      begin
        if not Read then
          begin
            WriteInteger(Progkey + '\Settings', 'SkinID', cbSkinList.ItemIndex);
            WriteInteger(Progkey + '\Settings', 'Level', tbDifLevel.Position);
            WriteBool(Progkey + '\Settings', 'ShowTips', cbShowTips.Checked);
            WriteBool(Progkey + '\Settings', 'ColoredBox', cbColored.Checked);
            WriteBool(Progkey + '\Settings', 'SoundEffects',
              cbSoundEffects.Checked);
          end
        else
          begin
            cbSkinList.ItemIndex := ReadInteger(Progkey + '\Settings', 'SkinID',
              0);
            tbDifLevel.Position := ReadInteger(Progkey + '\Settings', 'Level',
              25);
            cbShowTips.Checked := ReadBool(Progkey + '\Settings', 'ShowTips',
              False);
            cbColored.Checked := ReadBool(Progkey + '\Settings', 'ColoredBox',
              True);
            cbSoundEffects.Checked := ReadBool(Progkey + '\Settings',
              'SoundEffects', True);
            cbSkinList.OnClick(Self);
            tbDifLevel.OnChange(self);
          end;
      end;
    finally
      RegIni.Free;
    end;
end;

// oyun ierisinde 3x3=9 hcrelik toplam 9 grup olacak bu gruplar tespit etmek iin kullanlacak

function TfrmSudoku.FindGroup(Row: integer; Column: integer): string;

begin

  Result := '';

  if (Row >= 1) and (Row <= 3) then

    begin
      if (Column >= 1) and (Column <= 3) then result := '11';  // 1. grup balang noktas satr,stun olarak
      if (Column >= 4) and (Column <= 6) then result := '14'; // 2. grup
      if (Column >= 7) and (Column <= 9) then result := '17'; // 3. grup
    end;

  if (Row >= 4) and (Row <= 6) then

    begin
      if (Column >= 1) and (Column <= 3) then result := '41'; // 4. grup
      if (Column >= 4) and (Column <= 6) then result := '44'; // 5. grup
      if (Column >= 7) and (Column <= 9) then result := '47'; // 6. grup
    end;

  if (Row >= 7) and (Row <= 9) then

    begin
      if (Column >= 1) and (Column <= 3) then result := '71'; //7. grup
      if (Column >= 4) and (Column <= 6) then result := '74'; // 8. grup
      if (Column >= 7) and (Column <= 9) then result := '77'; // 9. grup
    end;
end;

// seili hcrenin bal bulunduu satr,stun ve grup iin girilebilecek
// ihtimallerin tesbiti iin kullanlacak NumberStr_27_Value deikeni
// satr, stun ve grup ta -0- lar dahil btn rakamlar ierecek ve
// daha sonra bu rakamlara gre girilebilecek rakamlar hesaplanacak

function TfrmSudoku.GetPossibilities(NumberStr_27_Value: string): string;

var
  i, j, k           : integer;

begin

  k := 1;
  BaseNumbers := '123456789'; // olabilecek btn ihtimaller ekleniyor

  if NumberStr_27_Value <> '' then

    begin

      for i := 1 to length(NumberStr_27_Value) do  //aktif hcrenin bulunduu stun,satr ve grup ta
                                                  //bulunan rakamlar BaseNumbers dize sinden siliniyor
                                                  //geriye sadece girilebilecek rakamlar kalyor

        begin
          j := ansipos(NumberStr_27_Value[i], BaseNumbers);  //silinecek veri pozisyonu belirleniyor
          delete(BaseNumbers, j, 1);    //ve siliniyor
        end;

      for i := 1 to length(BaseNumbers) - 1 do  // her ihtimal arasna "-" konuluyor

        begin
          k := k + 1;
          insert('-', BaseNumbers, k);
          k := k + 1;
        end;

      result := BaseNumbers; //ihtimaller sonu olarak dndrlyor
      exit;

    end

  else

    result := '';

end;

//Mouse un altndaki hcrenin kesitii stun ve satrda bulunan tm rakamlar
//yani dolu hcrelerdeki rakamlar bu rakamlar ift olabilir mouse un altndaki
// hcrede bulunan rakam hem stun hemde satrla kesitii iin ift saylr
//bo hcreler de -0- saylr dolays ile 18 karekter uzunluunda string bir
//deer dndrlr rn : 110024505067008394 gibi

function TfrmSudoku.NumberRefsForColRow(Column: integer; Row: integer;
  SourceArray: TSudokuArray): string;

var
  Index             : integer;
  NumbersStrVal     : string;

begin

  NumbersStrVal := '';

  for Index := 1 to 9 do
    begin
      NumbersStrVal := NumbersStrVal + inttostr(SourceArray[Column, Index]) +
        inttostr(SourceArray[Index, Row]);
    end;
  Result := NumbersStrVal;

end;

procedure TfrmSudoku.CreateRandomDigitsArray(var SourceRandomDigitsArray:
  TRandomDigitsArray);

var
  RandomDigit, i, j : integer;
  Duplicated        : Boolean;

begin

  RandomDigit := 0;
  Duplicated := False;

  for i := 1 to 9 do

    begin
      SourceRandomDigitsArray[i] := 0 // dizinin btn elemanlar -0- a eitleniyor
    end;

  for i := 1 to 9 do

    begin
      while Duplicated = False do // 9 elemanda farkl oluncaya kadar dng tekrarlanyor

        begin
          RandomDigit := randomRange(1, 10);
          Duplicated := True;

          for j := 1 to i do // her seferinde retilen say dizinin bandan sonuna kadar
                                        // kontrol ediliyor

            if SourceRandomDigitsArray[j] = RandomDigit then  // Eer random retilen say RandomDigitsSwapArray ierisinde varsa
                                                             // Tekrarlanarak farkl bir say retiliyor.
              Duplicated := False;
        end;

      SourceRandomDigitsArray[i] := RandomDigit;
      Duplicated := False;

    end;
end;

//CheckValueIsPossible eer InputValue hcreye girilebilecek deerler ierisinde ise true deilse false dndrr

function TfrmSudoku.CheckValueIsPossible(InputValue: integer; SourceColumn:
  integer; SourceRow: integer; SourceArray: TSudokuArray): Boolean;

var
  i, j, PossColumn, PossRow: integer;
  NumbersStr_18     : string; // aktif hcre ile kesien stun ve satr daki tm rakamlar
  NumbersStr_27     : string; // aktif hcre ile kesien stun ve satr ve gruptaki tm rakamlar
  Group             : string;  // 9 digit ten oluan grup
  GroupRow, GroupColumn: integer; //9 digit lik grubun satr stun bilgileri
  Possible          : Boolean; // geici deiken dngden knca sonucu functiona atamak iin

begin

  Result := False;
  NumbersStr_27 := '';
  NumbersStr_18 := '';
  Possible := False;

  for PossColumn := 1 to 9 do
    begin
      for PossRow := 1 to 9 do
        begin
          PossibilityArray[PossColumn, PossRow] := '';  // her seferinde ipularn tutan dizi temizleniyor
        end;
    end;

  Group := FindGroup(SourceRow, SourceColumn);  // ipularna baklacak hcrenin bulunduu grup bulunuyor.
  NumbersStr_18 := NumberRefsForColRow(SourceColumn, SourceRow, SourceArray);  // aktif hcrenin kesitii
                                                                              // stun ve satrdaki tm rakamlar
                                                                              //alnyor aktif hcre iki kere saylr
                                                                              // bo hcreler -0- rakamlar ift olabilir
  GroupRow := strtoint(Group[1]);
  GroupColumn := strtoint(Group[2]);
  for i := 0 to 2 do
    begin //3x3 lk grup ierisindeki her bir hcre
      for j := 0 to 2 do
        begin
          NumbersStr_27 := NumbersStr_27 + inttostr(SourceArray[GroupColumn + i,
            GroupRow + j]);               // grup iindeki -0- ve rakamlarda
          // diziye eklenip 27 rakam elde
          //ediliyor. aktif hcre 3 kere saylr
        end;
    end;
  NumbersStr_27 := NumbersStr_27 + NumbersStr_18;
  PossibilityArray[SourceColumn, SourceRow] := GetPossibilities(NumbersStr_27);  //Aktif hcre ihtimalleri srekli gncelleniyor

  // karlatrlan giri deeri girilebilir bir deerse sonu olarak true dner
  for i := 1 to length(PossibilityArray[SourceColumn, SourceRow]) do
    begin
      if inttostr(InputValue) = PossibilityArray[SourceColumn, SourceRow][i] then  // tekbir karakter -i-
        Possible := True;
    end;
  if Possible then
    begin
      result := true;
      exit;
    end;

end;

//Bu function ile tam zlm bir oyun retiliyor daha sonra bu zm GridSwapArray a ykleniyor
// sonra zlm olan oyundan zorluk derecesine gre baz hcreler temizlenecek ve zm olan ama
// zlmemi bir oyun oluturulup StringGrid e yklenecek

function TfrmSudoku.CreateSolvedGame(SourceArray: TSudokuArray; Gauge: TsGauge):
  boolean;
var
  Column, ProcColumn, ProcRow, Row, RandomDigitsIndex, Full, Count: integer;
  DifferentRandomDigitsArray: TRandomDigitsArray;

begin
  ProcColumn := 0;
  ProcRow := 0;
  Full := 10;

  Result := false;
  //Function kendini her ardnda 1-9 aras rastgele 9 elemanl dizi oluturuluyor
  CreateRandomDigitsArray(DifferentRandomDigitsArray);
  Gauge.Progress := Gauge.Progress + 1; // func. kendikendini ard iin artyor

  for Column := 1 to 9 do
    begin
      for Row := 1 to 9 do
        begin
          if SourceArray[Column, Row] = 0 then
            begin
              count := 0;
              for RandomDigitsIndex := 1 to 9 do
                begin
                  if
                    CheckValueIsPossible(DifferentRandomDigitsArray[RandomDigitsIndex], Column, Row, SourceArray) then
                    inc(count);
                end;
              if count < Full then
                begin
                  ProcColumn := Column;
                  ProcRow := Row;
                  Full := count;
                end;
            end;
        end;
    end;

  if Full = 10 then                     //StringGrid Doldu
    begin
      Result := true; //func. kendi kendini ard iin burada klyor
      exit;
    end;

  for RandomDigitsIndex := 1 to 9 do
    begin
      if CheckValueIsPossible(DifferentRandomDigitsArray[RandomDigitsIndex],
        ProcColumn, ProcRow, SourceArray) then
        begin
          SourceArray[ProcColumn, ProcRow] :=
            DifferentRandomDigitsArray[RandomDigitsIndex];
          SolvedGameArray[ProcColumn, ProcRow] :=
            DifferentRandomDigitsArray[RandomDigitsIndex];
          if CreateSolvedGame(SourceArray, Gauge) then
            begin //eer tm hcreler doldmu ve zm salanmsa func. bitiriliyor
              Result := true;
              exit;
            end;
        end;
    end;
end;

procedure TfrmSudoku.tbDifLevelChange(Sender: TObject);
begin
  DiffLevel := tbDifLevel.Position + 25;
  lbDifLevel.Caption := 'Zorluk : ' + InttoStr(DiffLevel);
end;

// bu function zorluk seviyesine yani bo hcre saysna ulalncaya kadar kendi kendini
// ararak nceden zm yklenmi olan dizi ierisinde DifficultyLevel says kadar
// bo yani sfr deerli hcre olana kadar kendi kendini arr.

function TfrmSudoku.CreateBlankCellMap(SourceArray: TSudokuArray;
  BlankCellCount: integer; DiffLevel: integer): boolean;

var
  Column, Row       : integer;
begin
  Result := False;

  //Bu dng ierisinde rastgele relinen stun ve satrlara baklyor
  // eer ilgili adreste -0- dan farkl bir deer varsa dngden klyor
  //ve dngden sonra alnan adres -0- a eitleniyor eer rastgele retilen deer
  // -0- sa dng sfrdan farkl rastgele bir adres bulana kadar devam ediyor
  repeat
    Column := RandomRange(1, 10); //Rastgele retilen stun bilgisi(1 dahil 10 hari)
    Row := RandomRange(1, 10); //Rastgele retilen Satr bilgisi(bkz RandomRange help)

  until SourceArray[Column][Row] <> 0; //alnan adresteki bilgi -0- sa dngy bitir

  if BlankCellCount = DiffLevel then //Eer sfra eitlenen adres says zorluk derecesine
    begin
      Result := true; //Eit olursa sonu olarak true dndr ve
      exit; //artk kendini arma functiondan k
    end;
  SourceArray[Column][Row] := 0; //dngde -0- olmayan adres alnp function
  // recursively alt iin burada -0- a eitleniyor.

  SolvedGameArray := SourceArray; // zlm oyun ierisinde her seferde bir hcre -0- yaplyor

  // burada func. kendini arp DiffLevel saysna ulamaya alyor
  if CreateBlankCellMap(SourceArray, BlankCellCount + 1, DiffLevel) then
    begin
      Result := true; //sayya ulanca True dndrp func. dan klyor
      exit;
    end;

end;

procedure TfrmSudoku.OpenGameFromFile(FileName: string);
var
  GameFile          : TextFile;
  x, y              : Integer;
  CellValue         : string;
  DifLev            : string;
  UsrKeyCnt         : string;

begin
  EnableSolvedMessage := True;
  UserKeyCount := 0;
  ClearSudokuGrid;

  try
    AssignFile(GameFile, FileName);
    Reset(GameFile);
    ReadLn(GameFile, DifLev);
    ReadLn(GameFile, UsrKeyCnt);
    UserKeyCount := StrToInt(EnDeCryptSudoku(UsrKeyCnt));
    DiffLevel := StrToInt(EnDeCryptSudoku(DifLev));
    with SudokuGrid do
      begin
        for x := 0 to 8 do
          for y := 0 to 8 do
            begin
              Readln(GameFile, CellValue);
              if EnDeCryptSudoku(CellValue)[2] = 'T' then  // ikinci karakter -T- True
                EditableCellsArray[x, y] := true
              else
                EditableCellsArray[x, y] := False;
              Cells[x, y] := EnDeCryptSudoku(CellValue)[1];  // birinci karakter hcre verisi
              if SudokuGrid.Cells[x, y] = ' ' then
                begin
                  AutoSolveHighlighterArray[x, y] := true;
                  SolvedGameArray[x + 1, y + 1] := 0;
                end
              else
                begin
                  SolvedGameArray[x + 1, y + 1] := strtoint(SudokuGrid.Cells[x,
                    y]);
                  AutoSolveHighlighterArray[x, y] := False;
                end;
            end;
      end;

    tbDifLevel.Position := DiffLevel - 25;
    lbInputCount.Caption := Inttostr(UserKeyCount);
    lbEstCount.Caption := Inttostr(DiffLevel - UserKeyCount);

  finally
    CloseFile(GameFile);
  end;                                  // try.

  SaveGameToFile(TempFolder + '\actgame.tmp');  // zlmemi oyun geici olarak kaydediliyor
end;

procedure TfrmSudoku.SaveGameToFile(FileName: string);
var
  GameFile          : TextFile;
  x, y              : Integer;
  LineValue         : string;
begin
  LineValue := '';
  try
    AssignFile(GameFile, FileName);
    Rewrite(GameFile);
    WriteLn(GameFile, EnDeCryptSudoku(InttoStr(DiffLevel)));
    WriteLn(GameFile, EnDeCryptSudoku(IntToStr(UserKeyCount)));

    with SudokuGrid do
      begin
        for x := 0 to 8 do
          begin
            for y := 0 to 8 do
              begin
                if EditableCellsArray[x, y] = True then
                  LineValue := Cells[x, y] + 'T'
                else
                  LineValue := Cells[x, y] + 'F';
                Writeln(GameFile, EnDeCryptSudoku(LineValue));
              end;
          end;
      end;
  finally
    CloseFile(GameFile);
  end;
end;

procedure TfrmSudoku.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ReadWriteSettings(False);
  if FileExists(TempFolder + '\actgame.tmp') then
    deleteFile(TempFolder + '\actgame.tmp');

end;

procedure TfrmSudoku.FormCreate(Sender: TObject);

var
  Col, Row          : integer;
begin

  Application.OnHint := DisplayHint;
  AutoSolve := False;
  CustomGame := False;
  ColoredBoxes := True;
  EnableSoundEffects := True;
  UserKeyCount := 0;

  KeyPadEnabled := True; // balangta tulara basma izni veriliyor

  ReadWriteSettings(True);
  DiffLevel := tbDifLevel.Position + 25;
  Randomize;
  for col := 1 to 9 do
    for Row := 1 to 9 do
      SolvedGameArray[col, Row] := 0; // SolvedGameArray tamamen sfrlanyor
  progGauge.Visible := False;
  GenerateSudokuGrid(False);
  EnableSolvedMessage := true;
  SudokuGrid.Selection := NoSelect;
  lbInputCount.Caption := Inttostr(UserKeyCount);
  lbEstCount.Caption := Inttostr(DiffLevel - UserKeyCount);

end;

procedure TfrmSudoku.ShowGameIsSolvedMessage;
begin

  sshowmessage('Tebrikler, Bu oyunu baaryla bitirdiniz. imdi Daha zor bir seviye seerek'
    + #13#10 +
    'veya hcre ipularn kapatp oyunu yle zmeyi deneyiniz.');
  EnableSolvedMessage := false;

end;

procedure TfrmSudoku.lbAuthorMouseEnter(Sender: TObject);
begin
  lbLogo.Visible := False;
  lbauthor.Caption :=
    'Gr ve nerileriniz iin E.Posta adresim : oktaykocaturk@gmx.net';
  PlaySound('AUTHOR', hInstance, SND_RESOURCE or SND_ASYNC or SND_NOWAIT);
end;

procedure TfrmSudoku.lbAuthorMouseLeave(Sender: TObject);
begin
  lbLogo.Visible := True;
  lbauthor.Caption := 'Copyright 2006 by Oktay KOCATRK';
end;

procedure TfrmSudoku.SudokuGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);

var
  x, y              : Integer;
  CellText          : string;

begin
  if (ACol in [0..8]) and (ARow in [0..8]) then

    with (Sender as TStringGrid).Canvas do

      begin

        CellText := (Sender as TStringGrid).Cells[ACol, ARow];
        x := (Rect.Left + 20) - (textWidth(CellText) div 2);  // burada girilen rakamn hcrenin
        y := (Rect.Top + 20) - (textHeight(CellText) div 2);  // tam ortasna hizalanmas salanyor

        if ColoredBoxes then Brush.Color := clWhite;

        if (ACol in [3..5]) or (ARow in [3..5]) then
          begin
            if ColoredBoxes then
              begin
                case cbSkinlist.ItemIndex of
                  0: Brush.Color := $00DBDBDB; //Deri
                  1: Brush.Color := $00FAEAD8; //Mavi
                  2: Brush.Color := $006DA7CD; //Ahap
                end;
              end;
          end;
        if (ACol in [3..5]) and (ARow in [3..5]) then
          begin
            if ColoredBoxes then Brush.Color := clWhite;
          end;

        if (gdSelected in State) and (EditableCellsArray[GridColumn, GridRow] =
          True) then
          begin
            Brush.Color := $008CFFC6;   //$00C5FEFB; //clTeal;
            TextRect(Rect, x, y, CellText);

          end;

        if (EditableCellsArray[ACol, ARow] = True) and (not CustomGame) then
          Font.Color := clRed;          //girilen karakterler

        if AutoSolve then
          begin
            if not CustomGame then
              begin
                if EditableCellsArray[ACol, ARow] = True then
                  Font.Color := clRed;
                if AutoSolveHighlighterArray[ACol, ARow] = True then
                  Font.Color := clBlue;
              end
            else
              if AutoSolveHighlighterArray[ACol, ARow] = False then
              Font.Color := clBlue;
          end;
        TextRect(Rect, x, y, CellText);
        TextOut(x, y, CellText);
        if not ColoredBoxes then
          begin
            SudokuGrid.Color := clWhite;
            Brush.Color := SudokuGrid.Color; // seim sfrlanyor
            if (ARow = 3) or (ARow = 6) then
              begin
                Pen.Color := clRed;
                Pen.Width := 2;
                MoveTo(Rect.Left, Rect.Top);
                LineTo(Rect.Right, Rect.Top);
              end;
            if (Acol = 3) or (Acol = 6) then
              begin
                Pen.Color := clRed;
                Pen.Width := 2;
                MoveTo(Rect.left, Rect.top);
                LineTo(Rect.left, Rect.bottom);
              end;
          end;

      end;

end;

procedure TfrmSudoku.cbColoredClick(Sender: TObject);
begin
  ColoredBoxes := cbColored.Checked;
  SudokuGrid.Repaint;
  SudokuGrid.Refresh;
end;

procedure TfrmSudoku.cbShowTipsClick(Sender: TObject);
begin
  if cbShowTips.Checked = false then
    begin
      lbMouseInCell.Caption := '';
      lbSelectedCell.Caption := '';
    end;

end;

procedure TfrmSudoku.cbSkinListClick(Sender: TObject);
begin
  if sknmngr.SkinName <> cbSkinList.Items[cbSkinList.ItemIndex] then
    sknmngr.SkinName := cbSkinList.Items[cbSkinList.ItemIndex];
  if sknmngr.SkinName = 'Mavi Plastik' then
    begin
      cbShowTips.Font.Color := clBlack;
      cbColored.Font.Color := clBlack;
      cbSoundEffects.Font.Color := clBlack;
    end
  else
    begin
      cbShowTips.Font.Color := clWhite;
      cbColored.Font.Color := clWhite;
      cbSoundEffects.Font.Color := clWhite;
    end;

end;

procedure TfrmSudoku.cbSoundEffectsClick(Sender: TObject);
begin
  EnableSoundEffects := cbSoundEffects.Checked;
end;

procedure TfrmSudoku.ClickKeyPadButtons(Sender: TObject);

var
  KeyPadButtonValue : Char;
begin

  KeyPadButtonValue := Chr((sender as TsSpeedButton).Tag);
  SendKeyPadValues(KeyPadButtonValue);
end;

procedure TfrmSudoku.SudokuGridMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; x, y: Integer);

begin
  SudokuGrid.MouseToCell(x, y, GridColumn, GridRow);  //farenin bulunduu hcrenin koordinatlar
                                                      // global GridColumn ve GridRow deikenlerine
                                                      //atanyor

  if cbShowTips.Checked = true then
    begin
      if SolvedGameArray[GridColumn + 1, GridRow + 1] = 0 then
        lbSelectedCell.Caption := 'Seili hcre ihtimalleri : ' +
          PossibilityArray[GridColumn + 1, GridRow + 1]
      else
        begin
          lbSelectedCell.Caption := '';
        end;
    end;

  if not GameIsSolved then // bu zlm oyunda ihtimal yok hatas vermesin diye eklendi

    if AutoSolveHighLighterArray[GridColumn, GridRow] then

      if (PossibilityArray[GridColumn + 1, GridRow + 1] = '') and
        (EditableCellsArray[GridColumn, GridRow] = True) then

        begin
          lbSelectedCell.Caption := '';
          lbMouseInCell.Caption := '';
          if EnableSoundEffects then
            PlaySound('NOTCANDIDATE', hInstance, SND_RESOURCE or SND_ASYNC or
            SND_NOWAIT);
          if sMessageDlg('Uyar', 'Bu hcreye girilebilecek ihtimal kalmad.'
            + #13#10 +
            'Bu oyunu yeniden balatabilir veya yeni bir oyun balatabilirsiniz.' + #13#10#13#10
              +
            'imdi bu oyunu yeniden balatmak istiyormusunuz ?', mtWarning,
              [mbyes, mbNo], 0) = IDyES then
            begin
              OpenGameFromFile(TempFolder + '\actgame.tmp');
            end
          else
            btnNewGame.OnClick(self);
          SudokuGrid.Repaint;
        end;

end;

procedure TfrmSudoku.SudokuGridMouseLeave(Sender: TObject);
begin
  lbSelectedCell.Caption := '';
  lbMouseInCell.Caption := '';
end;

procedure TfrmSudoku.CreateSudokuMask;
var
  i, j              : integer;
begin
  //burada SolvedGameArray ierisinde Bir oyun oluturuluyor
  //DifficultyLevel derine gre bo hcreler oluuruluyor

  CreateBlankCellMap(SolvedGameArray, 0, DiffLevel);

  for i := 1 to 9 do
    for j := 1 to 9 do
      begin
        SudokuGrid.Cells[i - 1, j - 1] := IntToStr(SolvedGameArray[i, j]);
        AutoSolveHighlighterArray[i - 1, j - 1] := False;

        if SudokuGrid.Cells[i - 1, j - 1] = '0' then  //burada ClearSudokuGrid ierisinden tm
          begin //false yaplan EditableCellsArray dizisi
            SudokuGrid.Cells[i - 1, j - 1] := ' ';  //ierisinde string gird de bo olan
            EditableCellsArray[i - 1, j - 1] := True;  //hcrelere denk gelenler True yaplyor
            AutoSolveHighlighterArray[i - 1, j - 1] := True;
          end;
      end;

end;

procedure TfrmSudoku.pnHeaderMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; x, y: Integer);
const
  sc_dragmove       = $F012;
begin
  releasecapture;
  twincontrol(application.mainform).perform(wm_syscommand, sc_dragmove, 0);
end;

procedure TfrmSudoku.btnOpenGameClick(Sender: TObject);
begin
  //  AutoSolve := False;
  if OpenDlg.Execute then
    if OpenDlg.FileName <> '' then
      OpenGameFromFile(OpenDlg.FileName);
  SudokuGrid.Selection := NoSelect;

end;

procedure TfrmSudoku.btnSaveGameClick(Sender: TObject);
begin
  if not GameIsSolved then
    if SaveDlg.Execute then
      if SaveDlg.FileName <> '' then
        SaveGameToFile(SaveDlg.FileName);
end;

procedure TfrmSudoku.btnExitClick(Sender: TObject);
var
  Col, Row, CellSum : Integer;
begin
  CellSum := 0;
  with application do
    for col := 0 to 8 do
      begin
        for Row := 0 to 8 do
          begin
            if SudokuGrid.Cells[col, Row] <> ' ' then
              CellSum := CellSum + StrToInt(SudokuGrid.Cells[col, Row]);
          end;
      end;

  if CellSum <> SudokuCellSum then

    if sMessageDlg('Kaydet',
      'Oyundan kmadan nce oyunu kaydetmek istermiz?',
      mtConfirmation, [mbyes, mbNo], 0) = IDyES then
      if SaveDlg.Execute then
        SaveGameToFile(SaveDlg.FileName);
  close;
end;

procedure TfrmSudoku.btnNewGameClick(Sender: TObject);
begin
  AutoSolve := False;
  EnableSolvedMessage := true;
  CustomGame := False;
  ClearSudokuGrid;
  Sleep(10);
  GenerateSudokuGrid(False);
  lbSelectedCell.Caption := '';
  lbMouseInCell.Caption := '';
  SudokuGrid.Selection := NoSelect;
  UserKeyCount := 0;

  lbInputCount.Caption := Inttostr(UserKeyCount);
  lbEstCount.Caption := Inttostr(DiffLevel - UserKeyCount);

end;

procedure TfrmSudoku.btnCustomGameClick(Sender: TObject);
begin
  CustomGame := True;
  ClearSudokuGrid;
end;

procedure TfrmSudoku.btnSolveGameClick(Sender: TObject);

begin
  if not GameIsSolved then
    begin
      AutoSolve := True;
      GenerateSudokuGrid(True);
      if FileExists(TempFolder + '\actgame.tmp') then
        deleteFile(TempFolder + '\actgame.tmp');
    end
  else
    if sMessageDlg('zlm Oyun', 'Bu oyunu zaten zdnz.' +
      #13#10#13#10 +
    'imdi yeni bir oyun balatmak istiyormusunuz ?', mtConfirmation, [mbyes,
      mbNo], 0) = IDyES then
    btnNewGame.OnClick(self);

end;

function TfrmSudoku.EnDeCryptSudoku(const Value: string): string;
var
  CharIndex         : Integer;
  ReturnValue       : string;
begin
  ReturnValue := '';
  for CharIndex := 1 to Length(Value) do
    begin
      ReturnValue := ReturnValue + chr(not (ord(Value[CharIndex])));
    end;
  Result := ReturnValue;
end;

procedure TfrmSudoku.btnPrnPreviewGameClick(Sender: TObject);
var
  i, j              : integer;
begin

  for i := 0 to 8 do
    for j := 0 to 8 do
      frmGamePrintPreview.PrintSudokuGrid.Cells[i, j] := SudokuGrid.Cells[i, j];
  frmGamePrintPreview.PrintSudokuGrid.Selection := NoSelect;
  frmGamePrintPreview.ShowModal;
end;

procedure TfrmSudoku.btnPrintGameClick(Sender: TObject);
var
  i, j              : integer;
begin

  for i := 0 to 8 do
    for j := 0 to 8 do
      frmGamePrintPreview.PrintSudokuGrid.Cells[i, j] := SudokuGrid.Cells[i, j];

  if PrinterSetUpdialog1.Execute then
    begin
      frmGamePrintPreview.show;
      frmGamePrintPreview.PrintSudokuGame(frmGamePrintPreview.cbCenter.Checked);
    end;
end;

procedure tfrmSudoku.ClearSudokuGrid;

var
  i, j              : integer;
begin
  for i := 1 to 9 do
    for j := 1 to 9 do
      begin
        SolvedGameArray[i, j] := 0;
        EditableCellsArray[i - 1, j - 1] := false;  // burada tm hcreler balang olarak giri izni yasaklanyor
        AutoSolveHighlighterArray[i - 1, j - 1] := false;
        SudokuGrid.Cells[i - 1, j - 1] := ' ';
      end;
  progGauge.Progress := 0;
  KeyPadEnabled := True; // burada oyun her temizlendiinde tulara izin veriliyor

end;

procedure TfrmSudoku.GenerateSudokuGrid(Solved: boolean);
var
  Col, Row          : integer;
begin
  progGauge.MinValue := 0;
  progGauge.MaxValue := 100;
  progGauge.Progress := 0;
  for Col := 1 to 9 do
    for Row := 1 to 9 do
      begin
        PossibilityArray[Col, Row] := '';
      end;
  progGauge.Visible := True;

  // burada oyun nce zlm olarak retiliyor(func. kendi kendini arr)
  if not CreateSolvedGame(SolvedGameArray, progGauge) then
    begin
      if CustomGame then
        begin
          if sMessageDlg('zmsz zel Oyun',
            'Hazrladnz bu zel oyunun zm yok.' + #13#10#13#10 +
            'imdi yeni bir oyun balatmak istiyormusunuz ?', mtWarning,
              [mbyes, mbNo], 0) = IDyES then
            btnNewGame.OnClick(self)
          else
            btnCustomGame.OnClick(self);
          SudokuGrid.Repaint;
        end
      else
        begin
          if sMessageDlg('zmsz oyun',
            'Bu oyunun girdiiniz rakamlarla zm yok.' + #13#10 +
            'Bu oyunu yeniden balatabilir veya yeni bir oyun balatabilirsiniz.' + #13#10#13#10
              +
            'imdi bu oyunu yeniden balatmak istiyormusunuz ?', mtError,
              [mbyes, mbNo], 0) = IDyES then
            begin
              OpenGameFromFile(TempFolder + '\actgame.tmp');
            end
          else
            btnNewGame.OnClick(self);
          SudokuGrid.Repaint;
        end;
    end
  else
    begin

      for Col := 1 to 9 do
        begin
          for Row := 1 to 9 do
            begin
              if Solved = true then
                //Eer oyun program tarafndan zlecekse zm stringGride ykleniyor
                SudokuGrid.Cells[Col - 1, Row - 1] :=
                  inttostr(SolvedGameArray[Col, Row]);
            end;
        end;
      if Solved = false then
        begin
          CreateSudokuMask;
          SaveGameToFile(TempFolder + '\actgame.tmp');  // zlmemi oyun geici olarak kaydediliyor
        end;
      progGauge.Visible := False;
    end;
end;

procedure TfrmSudoku.Sleep(Miliseconds: Cardinal);
var
  cTmp              : Cardinal;
begin
  cTmp := GetTickCount + Miliseconds;
  while GetTickCount < cTmp do
    Application.ProcessMessages;

end;

procedure TfrmSudoku.SudokuGridMouseMove(Sender: TObject; Shift: TShiftState; x,
  y: Integer);
var
  MouseColumn, MouseRow: integer;
begin
  if cbShowTips.Checked = true then
    begin
      if (x < SudokuGrid.Width - 10) and (y < SudokuGrid.Height - 10)
        and (x > 0) and (y > 0) then
        begin
          SudokuGrid.MouseToCell(x, y, MouseColumn, MouseRow);  // mouse un bulunduu hcre koordinatlar alnyor
          CheckValueIsPossible(0, MouseColumn + 1, MouseRow + 1,
            SolvedGameArray);             //burada gezilen her hcrenin
          //ipucu bilgileri gncelleniyor
          // InputValue = 0 olmas bu sebepten
          // nk dnglerde 1 den balanyor
          if SolvedGameArray[MouseColumn + 1, MouseRow + 1] = 0 then  // eer hcre bosa ipucu gsteriliyor
            lbMouseInCell.Caption := 'Aktif hcre ihtimalleri : ' +
              PossibilityArray[MouseColumn + 1, MouseRow + 1]
          else
            lbMouseInCell.Caption := '';
        end;
    end;
end;

function TfrmSudoku.GameIsSolved;
var
  Col, Row          : integer;
  CellSum           : Integer;
begin
  result := False;
  CellSum := 0; // Tm hcreler dolduunda bu deikenin deeri 405 olur
  for Col := 0 to 8 do
    begin
      for Row := 0 to 8 do
        begin
          if SolvedGameArray[Col + 1, Row + 1] > 0 then
            CellSum := CellSum + SolvedGameArray[Col + 1, Row + 1];
        end;
    end;

  if CellSum = SudokuCellSum then Result := True;
end;

procedure TfrmSudoku.SudokuGridKeyPress(Sender: TObject; var Key: Char);
begin

  if (Key >= '0') and (Key <= '9') then
    begin
      SendKeyPadValues(Key);
    end;
end;

procedure TfrmSudoku.SendKeyPadValues(var KeyPadButtonValue: Char);

begin
  if not GameIsSolved then              //oyun tamamen zlmemise
    begin
      if EditableCellsArray[GridColumn, GridRow] then  // eer hcreye giri izni verilmisse
        if KeyPadEnabled then           // eer tulara basma izni verilmisse
          if EnableSoundEffects then
            PlaySound('CLICK', hInstance, SND_RESOURCE or SND_ASYNC or
            SND_NOWAIT);
      //eer hcre bosa veya bilgi giriine izin veriliyorsa
      // bo hcreye bilgi girilmise de deitirilebilsin
      if (SudokuGrid.Cells[GridColumn, GridRow] = ' ') or
        (EditableCellsArray[GridColumn, GridRow] = true) then
        begin
          // eer baslan tu -0- dan farkl ve zm dizisinin ilgili hcresi baslan karakterden farkl ise
          if (KeyPadButtonValue <> '0') and (SolvedGameArray[GridColumn + 1,
            GridRow + 1] <> strtoint(KeyPadButtonValue)) then
            begin
              lbSelectedCell.Caption := '';
              // baslan karakter zm tablosuna gre ihtimaller dahilinde deilse
              if CheckValueIsPossible(strtoint(KeyPadButtonValue), GridColumn +
                1, GridRow + 1, SolvedGameArray) = False then

                begin
                  if EnableSoundEffects then
                    PlaySound('NOTPOSSIBLE', hInstance, SND_RESOURCE or SND_ASYNC
                    or SND_NOWAIT);
                  lbMouseInCell.Caption := ' Bu hcreye -' + KeyPadButtonValue +
                    '- ' + 'giremezsiniz.';
                end
              else // baslan karakter zm tablosuna gre ihtimaller dahilinde ise
                begin
                  SolvedGameArray[GridColumn + 1, GridRow + 1] :=
                    strtoint(KeyPadButtonValue);  // zm tablosunun ilgili alanna karakteri gir
                  SudokuGrid.Cells[GridColumn, GridRow] := KeyPadButtonValue;  // string girde girilen deeri yaz
                  AutoSolveHighlighterArray[GridColumn, GridRow] := False;  // kullancnn girdii deerler farkl oyunun girdi deerler farkl renk olsun
                  UserKeyCount := UserKeyCount + 1;
                  if CustomGame then
                    begin
                      AutoSolveHighlighterArray[GridColumn, GridRow] := True;  // zel oyunda kii girdii hcreleri deitirsin
                    end;
                end;
            end;
        end;

      if (KeyPadButtonValue = '0') and (EditableCellsArray[GridColumn, GridRow]
        = True) then
        begin
          SudokuGrid.Cells[GridColumn, GridRow] := ' ';
          SolvedGameArray[GridColumn + 1, GridRow + 1] := 0;
          KeyPadButtonValue := ' ';
          AutoSolveHighlighterArray[GridColumn, GridRow] := True; //false;
          if UserKeyCount > 0 then UserKeyCount := UserKeyCount - 1;

        end;

      if EnableSolvedMessage = true then
        begin
          if GameIsSolved = true then
            begin
              if EnableSoundEffects then
                PlaySound('SOLVED', hInstance, SND_RESOURCE or SND_ASYNC or
                SND_NOWAIT);
              lbInputCount.Caption := Inttostr(UserKeyCount);
              lbEstCount.Caption := Inttostr(DiffLevel - UserKeyCount);
              ShowGameIsSolvedMessage;

              KeyPadEnabled := False;
            end;
        end;
    end
  else
    if sMessageDlg('Tebrikler', 'Bu oyunu zaten zdnz.' + #13#10#13#10 +
    'imdi yeni bir oyun balatmak istiyormusunuz ?', mtConfirmation, [mbyes,
      mbNo], 0) = IDyES then
    btnNewGame.OnClick(self);

  lbInputCount.Caption := Inttostr(UserKeyCount);
  lbEstCount.Caption := Inttostr(DiffLevel - UserKeyCount);

end;

procedure TfrmSudoku.SudokuGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);

begin
  GridColumn := ACol;
  GridRow := ARow;

  CheckValueIsPossible(0, ACol + 1, ARow + 1, SolvedGameArray);

  if cbShowTips.Checked = true then
    begin
      if SolvedGameArray[ACol + 1, ARow + 1] = 0 then
        lbMouseInCell.Caption := 'Aktif hcre ihtimalleri : ' +
          PossibilityArray[ACol + 1, ARow + 1]
      else
        lbMouseInCell.Caption := '';

      if SolvedGameArray[ACol + 1, ARow + 1] = 0 then
        lbSelectedCell.Caption := 'Seili hcre ihtimalleri : ' +
          PossibilityArray[ACol + 1, ARow + 1]

      else

        lbSelectedCell.Caption := '';
    end;

end;

end.

