unit frmPrintPreview;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ExtCtrls, sSkinProvider, sButton, sPanel,
  sSpeedButton, sLabel, printers, sCheckBox, Buttons;

type
  TfrmGamePrintPreview = class( TForm )
    sSkinProvider1 : TsSkinProvider;
    sPanel1 : TsPanel;
    PrintSudokuGrid : TStringGrid;
    sPanel3 : TsPanel;
    sLabelFX2 : TsLabelFX;
    sPanel4 : TsPanel;
    sButton1 : TsButton;
    btnExit : TsSpeedButton;
    cbCenter : TsCheckBox;
    procedure btnExitClick( Sender : TObject );
    procedure sPanel3MouseDown( Sender : TObject; Button : TMouseButton;
      Shift : TShiftState; X, Y : Integer );
    procedure sButton1Click( Sender : TObject );
    procedure PrintSudokuGridDrawCell( Sender : TObject; ACol, ARow : Integer;
      Rect : TRect; State : TGridDrawState );
  private
  public

    procedure PrintSudokuGame( Center : Boolean );

  end;

var
  frmGamePrintPreview : TfrmGamePrintPreview;

implementation

{$R *.dfm}
uses frmMain;

procedure TfrmGamePrintPreview.btnExitClick( Sender : TObject );
begin
  frmGamePrintPreview.Close;
end;

procedure TfrmGamePrintPreview.PrintSudokuGame( Center : Boolean );
var
  ScaleX, ScaleY, x, y : Integer;
  RR : TRect;
begin
  with Printer do
    begin
      BeginDoc;
      x := 0;
      y := 0;
      try
        ScaleX := GetDeviceCaps( Handle, logPixelsX ) div PixelsPerInch;
        ScaleY := GetDeviceCaps( Handle, logPixelsY ) div PixelsPerInch;
        if Center then
          begin
            X := ( ( printer.PageWidth div 2 ) - ( ( PrintSudokuGrid.Width div 2 ) * scaleX ) );
            Y := ( ( printer.PageHeight div 2 ) - ( ( PrintSudokuGrid.Height div 2 ) * scaleY ) );
          end;
        RR := Rect( x, y, x + ( PrintSudokuGrid.Width * scaleX ), y + ( PrintSudokuGrid.Height * scaleY ) );
        canvas.copyrect( rr, PrintSudokuGrid.canvas, PrintSudokuGrid.clientrect );
      finally
        EndDoc;
      end;
    end;
end;

procedure TfrmGamePrintPreview.PrintSudokuGridDrawCell( Sender : TObject; ACol, ARow : Integer;
  Rect : TRect; State : TGridDrawState );

var
  X, Y : Integer;
  S : string;
begin

  with PrintSudokuGrid.Canvas do

    begin
      Brush.Color := clWhite;
      Font.Size := 20;

      if ( EditableCellsArray[ACol, ARow] = True ) and ( not CustomGame ) then
        Font.Color := clRed;

      if ( AutoSolve = True ) and ( AutoSolveHighlighterArray[ACol, ARow] = True ) then
        Font.Color := clBlue;

      TextRect( Rect, 10, 2, PrintSudokuGrid.Cells[ACol, ARow] );
      s := PrintSudokuGrid.Cells[ACol, ARow];
      x := 12 + Rect.Left;
      y := 1 + Rect.Top + ( Rect.Bottom - Rect.Top - TextHeight( s ) ) div 2;
      Font.Style := [fsBold];
      TextOut( x, y, s );

      PrintSudokuGrid.Color := clWhite;

      if ( Arow = 3 ) or ( Arow = 6 ) then
        begin
          Pen.Color := clSilver;
          Pen.Width := 3;
          MoveTo( Rect.Left, Rect.Top );
          LineTo( Rect.Right, Rect.Top );
        end;
      if ( Acol = 3 ) or ( Acol = 6 ) then
        begin
          Pen.Color := clSilver;
          Pen.Width := 3;
          MoveTo( Rect.left, Rect.top );
          LineTo( Rect.left, Rect.bottom );
        end;
    end;
end;

procedure TfrmGamePrintPreview.sButton1Click( Sender : TObject );
begin
  PrintSudokuGame( cbCenter.Checked );
end;

procedure TfrmGamePrintPreview.sPanel3MouseDown( Sender : TObject; Button : TMouseButton;
  Shift : TShiftState; X, Y : Integer );
const
  sc_dragmove = $F012;
begin
  releasecapture;
  twincontrol( frmGamePrintPreview ).perform( wm_syscommand, sc_dragmove, 0 );
end;

end.

